deploying to staging:
    stage: deploy
    image: google/cloud-sdk
    services:
        - docker:stable-dind # needed for docker-in-docker
    script:
        - echo deploy $CI_COMMIT_TAG of $CI_PROJECT_NAME to $ENVIRONMENT
        # image registry authorization
        - echo $GCLOUD_SERVICE_KEY > ${HOME}/gcloud-service-key.json
        - gcloud auth activate-service-account --key-file ${HOME}/gcloud-service-key.json
        - gcloud --quiet config set account gitlab@$PROJECT_NAME.iam.gserviceaccount.com
        - gcloud --quiet config set project $PROJECT_NAME
        - gcloud --quiet config set compute/zone $ZONE
        - gcloud auth configure-docker --quiet

        # builder env
        # building image
        - docker pull $GCE_REGISTRY_BASEPATH/${CI_PROJECT_NAME}_$ENVIRONMENT-build-env:latest || true # || true so it does not fail if image is not existing yet
        - docker build --cache-from $GCE_REGISTRY_BASEPATH/${CI_PROJECT_NAME}_$ENVIRONMENT-build-env:latest -t ${CI_PROJECT_NAME}_$ENVIRONMENT-build-env:$CI_COMMIT_TAG -f ./deployment/$ENVIRONMENT.dockerfile --target build-env .
        # tagging image
        - docker tag ${CI_PROJECT_NAME}_$ENVIRONMENT-build-env:$CI_COMMIT_TAG $GCE_REGISTRY_BASEPATH/${CI_PROJECT_NAME}_$ENVIRONMENT-build-env:$CI_COMMIT_TAG
        - docker tag ${CI_PROJECT_NAME}_$ENVIRONMENT-build-env:$CI_COMMIT_TAG $GCE_REGISTRY_BASEPATH/${CI_PROJECT_NAME}_$ENVIRONMENT-build-env:latest
        # pushing image to registry
        - docker push $GCE_REGISTRY_BASEPATH/${CI_PROJECT_NAME}_$ENVIRONMENT-build-env:$CI_COMMIT_TAG
        - docker push $GCE_REGISTRY_BASEPATH/${CI_PROJECT_NAME}_$ENVIRONMENT-build-env:latest

        # runtime env
        # building image
        - docker pull $GCE_REGISTRY_BASEPATH/${CI_PROJECT_NAME}_$ENVIRONMENT:latest || true # || true so it does not fail if image is not existing yet
        - docker build --cache-from $GCE_REGISTRY_BASEPATH/${CI_PROJECT_NAME}_$ENVIRONMENT:latest --cache-from $GCE_REGISTRY_BASEPATH/${CI_PROJECT_NAME}_$ENVIRONMENT-build-env:latest -t ${CI_PROJECT_NAME}_$ENVIRONMENT:$CI_COMMIT_TAG --build-arg ARG_APP_VERSION=$CI_COMMIT_TAG -f ./deployment/$ENVIRONMENT.dockerfile .
        # tagging image
        - docker tag ${CI_PROJECT_NAME}_$ENVIRONMENT:$CI_COMMIT_TAG $GCE_REGISTRY_BASEPATH/${CI_PROJECT_NAME}_$ENVIRONMENT:$CI_COMMIT_TAG
        - docker tag ${CI_PROJECT_NAME}_$ENVIRONMENT:$CI_COMMIT_TAG $GCE_REGISTRY_BASEPATH/${CI_PROJECT_NAME}_$ENVIRONMENT:latest
        # pushing image to registry
        - docker push $GCE_REGISTRY_BASEPATH/${CI_PROJECT_NAME}_$ENVIRONMENT:$CI_COMMIT_TAG
        - docker push $GCE_REGISTRY_BASEPATH/${CI_PROJECT_NAME}_$ENVIRONMENT:latest

        # set the deployment-image to the updated image
        - gcloud container clusters get-credentials $K8S_CLUSTER_NAME
        - kubectl set image deployment/sp-api-$ENVIRONMENT app=$GCE_REGISTRY_BASEPATH/${CI_PROJECT_NAME}_$ENVIRONMENT:$CI_COMMIT_TAG --namespace $K8S_NAMEPSACE
        - kubectl set image deployment/sp-api-test app=$GCE_REGISTRY_BASEPATH/${CI_PROJECT_NAME}_$ENVIRONMENT:$CI_COMMIT_TAG --namespace $K8S_NAMEPSACE
